// stdafx.h : include file for standard system include files,
// or project specific include files that are used frequently,
// but are changed infrequently

#pragma once

#ifndef STRICT
#define STRICT
#endif

// Modify the following defines if you have to target a platform prior to the ones specified below.
// Refer to MSDN for the latest info on corresponding values for different platforms.
#ifndef WINVER				// Allow use of features specific to Windows 95 and Windows NT 4 or later.
#define WINVER 0x0400		// Change this to the appropriate value to target Windows 98 and Windows 2000 or later.
#endif

#ifndef _WIN32_WINNT		// Allow use of features specific to Windows NT 4 or later.
#define _WIN32_WINNT 0x0400	// Change this to the appropriate value to target Windows 2000 or later.
#endif						

#ifndef _WIN32_WINDOWS		// Allow use of features specific to Windows 98 or later.
#define _WIN32_WINDOWS 0x0410 // Change this to the appropriate value to target Windows Me or later.
#endif

#ifndef _WIN32_IE			// Allow use of features specific to IE 4.0 or later.
#define _WIN32_IE 0x0400	// Change this to the appropriate value to target IE 5.0 or later.
#endif

//#define _ATL_APARTMENT_THREADED
#define _ATL_MULTI_THREADED
#define _ATL_NO_AUTOMATIC_NAMESPACE

#define _ATL_CSTRING_EXPLICIT_CONSTRUCTORS	// some CString constructors will be explicit

// turns off ATL's hiding of some common and often safely ignored warning messages
#define _ATL_ALL_WARNINGS


#include "resource.h"
#include "pntypes.h"
#include <shlobj.h>
#include <atlbase.h>
#include <initguid.h>
#include "pncom.h"
#include <atlcom.h>
#include <atlcoll.h>
#include "pnwintyp.h"
#include "rmacore.h"
#include "rmacomm.h"
#include "rmaclsnk.h"
#include "rmaausvc.h"
#include "rmapckts.h"
#include "rmawin.h"
#include "rmaevent.h"
#include <typeinfo.h>

using namespace ATL;

template <class Base>
class CComDebugObject : public CComObject<Base>
{
public:
	CComDebugObject(void* = NULL) throw() : CComObject<Base>()
	{
		ATLTRACE2("Constructing %s\n", typeid(Base).name());
	}
	~CComDebugObject() throw()
	{
		ATLTRACE2("Destroying %s\n", typeid(Base).name());
	}
	STDMETHOD_(ULONG, AddRef)() throw()
	{
		ULONG result = CComObject<Base>::AddRef();
		ATLTRACE2("AddRefing (%d) on %s\n", result, typeid(Base).name());
		return result;
	}
	STDMETHOD_(ULONG, Release)() throw()
	{
		ULONG result = CComObject<Base>::Release();
		ATLTRACE2("Releasing (%d) on %s\n", result, typeid(Base).name());
		return result;
	}
	STDMETHOD(QueryInterface)(REFIID iid, void **ppvObject) throw ()
	{
		HRESULT hr = CComObject<Base>::QueryInterface(iid, ppvObject);
		ATLTRACE2("Querying Interface %08X-%04X-%04X-%02X%02X-%02X%02X%02X%02X%02X%02X on %s was %s\n",
			iid.Data1, iid.Data2, iid.Data3,
			iid.Data4[0], iid.Data4[1], iid.Data4[2], iid.Data4[3],
			iid.Data4[4], iid.Data4[5], iid.Data4[6], iid.Data4[7],
			typeid(Base).name(), (hr == S_OK ? "SUCCESSFUL" : "unsuccessful"));
		return hr;
	}
};

#ifdef _DEBUG
#define CCOMOBJECT CComDebugObject
#else
#define CCOMOBJECT CComObject
#endif