/*
 * RealThumb v0.20
 * RealThumbTest.cpp - Thumbnail extractor test application implementation
 * Copyright (c) 2003 Michael Barrientos
 * All rights reserved.
 * http://mb.n3.net/projects/
 */
// RealThumbTest.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "RealThumbTest.h"
#include "MainFrm.h"

#include "ChildFrm.h"
#include "RealThumbTestDoc.h"
#include "RealThumbTestView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CRealThumbTestApp

BEGIN_MESSAGE_MAP(CRealThumbTestApp, CWinApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
END_MESSAGE_MAP()


// CRealThumbTestApp construction

CRealThumbTestApp::CRealThumbTestApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}


// The one and only CRealThumbTestApp object

CRealThumbTestApp theApp;

// CRealThumbTestApp initialization

BOOL CRealThumbTestApp::InitInstance()
{
	// InitCommonControls() is required on Windows XP if an application
	// manifest specifies use of ComCtl32.dll version 6 or later to enable
	// visual styles.  Otherwise, any window creation will fail.
	InitCommonControls();

	CWinApp::InitInstance();

	// Initialize OLE libraries
	if (!AfxOleInit())
	{
		AfxMessageBox(IDP_OLE_INIT_FAILED);
		return FALSE;
	}
#ifdef _DEBUG
	m_DLL = CoLoadLibrary(OLESTR("..\\RealThumb\\Debug\\RealThumb.dll"), TRUE);
#else
	m_DLL = CoLoadLibrary(OLESTR("..\\RealThumb\\Release\\RealThumb.dll"), TRUE);
#endif
	if (m_DLL == NULL) {
		ATLTRACE2("Could not find RealThumb.dll!");
		exit(1);
	}

	CComPtr<IClassFactory> tmp_ClassFactory;
	DLLGETCLASSOBJECTFUNC tmpFunc = (DLLGETCLASSOBJECTFUNC)GetProcAddress(m_DLL, "DllGetClassObject");
	if (!tmpFunc)
	{
		ATLTRACE2("DllGetClassObject not found!\n");
		exit(2);
	}
	HRESULT hr = tmpFunc(CLSID_CCoRealThumb, IID_IClassFactory, reinterpret_cast<LPVOID*>(&tmp_ClassFactory));
	ATLASSERT(hr == S_OK);
	hr = tmp_ClassFactory->CreateInstance(NULL, IID_IUnknown, reinterpret_cast<LPVOID*>(&m_RealThumb));
	ATLASSERT(hr == S_OK);

	AfxEnableControlContainer();
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	// of your final executable, you should remove from the following
	// the specific initialization routines you do not need
	// Change the registry key under which our settings are stored
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization
	SetRegistryKey(_T("Local AppWizard-Generated Applications"));
	LoadStdProfileSettings(4);  // Load standard INI file options (including MRU)
	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views
	CMultiDocTemplate* pDocTemplate;
	pDocTemplate = new CMultiDocTemplate(IDR_RealThumbTestTYPE,
		RUNTIME_CLASS(CRealThumbTestDoc),
		RUNTIME_CLASS(CChildFrame), // custom MDI child frame
		RUNTIME_CLASS(CRealThumbTestView));
	AddDocTemplate(pDocTemplate);
	// create main MDI Frame window
	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	m_pMainWnd = pMainFrame;
	// call DragAcceptFiles only if there's a suffix
	//  In an MDI app, this should occur immediately after setting m_pMainWnd
	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);
	// Dispatch commands specified on the command line.  Will return FALSE if
	// app was launched with /RegServer, /Register, /Unregserver or /Unregister.
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;
	// The main window has been initialized, so show and update it
	pMainFrame->ShowWindow(m_nCmdShow);
	pMainFrame->UpdateWindow();
	return TRUE;
}



// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()

// App command to run the dialog
void CRealThumbTestApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}


// CRealThumbTestApp message handlers

int CRealThumbTestApp::ExitInstance()
{
	ATLTRACE2("Exiting RTTestApp\n");
	// Need to null it out since we free the library next
	m_RealThumb = NULL;
	// CoFreeLibrary(m_DLL);
	return CWinApp::ExitInstance();
}